# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/06_entrypoints.flask_app.ipynb (unless otherwise specified).

__all__ = ['__all__', 'app', 'bus', 'index', 'etl_assignment_ep', 'etl_rbac', 'etl_uvgl', 'rbac_security_view',
           'view_uvgl', 'view_rbac_users']

# Cell
#export
from flask import Flask, jsonify, request
from ..service_layer import unit_of_work, views
from ..domain import commands
from collections import namedtuple
from ysyfinance import commons, bootstrap
from typing import Callable
from .functions import *

# Cell
__all__=['index','etl_assignment_ep']

# Cell
app = Flask(__name__)
bus = bootstrap.bootstrap()

# Cell
@app.route('/')
def index():
    return '<h1>YSYFinance Flask API Server</h1>'

# Cell
@app.route("/etl_assignment", methods=['POST'])
def etl_assignment_ep():
    try:
        cmd = commands.EtlAssignment(
            request.json['reference']
        )
        bus.handle(cmd)
    except Exception as e:
        return jsonify({'message': str(e)}), 400

    return 'OK', 202

# Cell
etl_rbac = make_etl_endpoint(
                    endpoint_name = 'etl_rbac', \
                    cmd = commands.EtlJob \
                         ( \
                            reference='ysyfinance.budget.domain.GeneralLedgerUsers', \
                            pipeline_names=['security','users']
                         ), \
                    bus = bus, \
                    app = app
                )

# Cell
etl_uvgl = make_etl_endpoint(
                    endpoint_name = 'etl_uvgl', \
                    cmd = commands.EtlJob \
                         ( \
                            reference='ysyfinance.budget.domain.UvGeneralLedger', \
                            pipeline_names=['default']
                         ), \
                    bus = bus, \
                    app = app
                )

# Cell
make_etl_endpoint(
                    endpoint_name = 'etl_glbudgetactual_rawinit', \
                    cmd = commands.EtlJob \
                         ( \
                            reference='ysyfinance.budget.domain.GlBudgetActual' , \
                            pipeline_names=['glbudgetactual_raw'], \
                            pipeline_args={'glbudgetactual_raw': {'is_init':True}}
                         ), \
                    bus = bus, \
                    app = app

                )

# Cell
make_etl_endpoint(
                    endpoint_name = 'etl_glbudgetactual_raw', \
                    cmd = commands.EtlJob \
                         ( \
                            reference='ysyfinance.budget.domain.GlBudgetActual' , \
                            pipeline_names=['glbudgetactual_raw']
                         ), \
                    bus = bus, \
                    app = app
                )

# Cell
make_etl_endpoint(
                    endpoint_name = 'etl_glbudgetactual_init', \
                    cmd = commands.EtlJob \
                         ( \
                            reference='ysyfinance.budget.domain.GlBudgetActual' , \
                            pipeline_names=['glbudgetactual'], \
                            pipeline_args={'glbudgetactual': {'is_init':True}}
                         ), \
                    bus = bus, \
                    app = app
                )

# Cell
make_etl_endpoint(
                    endpoint_name = 'etl_glbudgetactual', \
                    cmd = commands.EtlJob \
                         ( \
                            reference='ysyfinance.budget.domain.GlBudgetActual' , \
                            pipeline_names=['glbudgetactual']
                         ), \
                    bus = bus, \
                    app = app
                )

# Cell
rbac_security_view = make_view_endpoint(
                endpoint_name='view_rbac_security', \
                uow=bus.syn_uow, \
                reference='ysyfinance.budget.domain.GeneralLedgerUsers', \
                pipeline_name='security' , \
                app = app
              )

# Cell
view_uvgl = make_view_endpoint(
                endpoint_name='view_uvgl', \
                uow=bus.syn_uow, \
                reference='ysyfinance.budget.domain.UvGeneralLedger', \
                pipeline_name='default', \
                app = app
              )

# Cell
view_rbac_users = make_view_endpoint(
                endpoint_name='view_rbac_users', \
                uow=bus.syn_uow, \
                reference='ysyfinance.budget.domain.GeneralLedgerUsers', \
                pipeline_name='users', \
                app = app
              )

# Cell
make_view_endpoint(
                endpoint_name='view_glbudgetactual', \
                uow=bus.syn_uow, \
                reference='ysyfinance.budget.domain.GlBudgetActual', \
                pipeline_name='glbudgetactual', \
                app = app
              )

# Cell
make_view_endpoint(
                endpoint_name='view_glbudgetactual_raw', \
                uow=bus.syn_uow, \
                reference='ysyfinance.budget.domain.GlBudgetActual', \
                pipeline_name='glbudgetactual_raw', \
                app = app
              )

# Cell
if __name__ == '__main__':
    app.run(host='0.0.0.0')