# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/17_entrypoints.functions.ipynb (unless otherwise specified).

__all__ = ['__all__', 'make_etl_endpoint', 'make_view_endpoint']

# Cell
from flask import Flask
from ..domain import commands
from ..service_layer import messagebus, unit_of_work, views
from ysyfinance import commons
from typing import Callable
from flask import jsonify
__all__=['make_etl_endpoint', 'make_view_endpoint']

# Cell
def make_etl_endpoint(endpoint_name: str, \
                      cmd: commands.Command, \
                      bus: messagebus.MessageBus, \
                      app: Flask \
                     ) -> Callable :
    def etl_endpoint():
        try:
            bus.handle(cmd)
        except Exception as e:
            return jsonify({'message': str(e)}), 400

        return 'OK', 202
    etl_endpoint.__name__=endpoint_name
    return app.route(f"/{endpoint_name}", methods=['POST'])(etl_endpoint)

# Cell
def make_view_endpoint(endpoint_name: str, \
                  uow: unit_of_work.AbstractUnitOfWork, \
                  reference: str, \
                  pipeline_name: str, \
                  app: Flask) -> Callable:
    def view_endpoint():
        result = views.view_etl(uow, reference, pipeline_name)
        if not result:
            return 'not found', 404
        return jsonify(commons.jsonify_deltalake(result)), 200
    view_endpoint.__name__=endpoint_name
    return app.route(f"/{endpoint_name}", methods=['GET'])(view_endpoint)